<?php

namespace App\Http\Controllers;
use Illuminate\Support\Facades\Auth;

use Illuminate\Http\Request;
use App\Models\Timetable;
use App\Models\Student;
use App\Models\TimetableSchedule;
use App\Models\AttendanceChart;
use App\Models\Attendance;
use App\Models\Subject;
use App\Models\SecondLanguageAllotment;
use DB;

class AttendanceController extends Controller
{
    public function index()
    {
    	if(!Auth::check()){
			return redirect('/login');
		}
	    $data['breadcrumbs'] = [
		        ['link' => "attendance", 'name' => "Attendance"], ['name' => "Index"]
		    ];

		$day = date('l');
		//$day = 'Friday';
		$data['timetable_schedules'] = TimetableSchedule::where('day', $day)->get();
		$i = 0;
		foreach($data['timetable_schedules'] as $ts){
			$data['timetables'][$i] = Timetable::select('timetables.id', 'timetables.staff_id', 'timetables.class_id','timetables.subject_id','subjects.subject_title', 'subjects.subject_code', 'classes.class', 'classes.class_code','timetables.session_type')
									
									->leftJoin('subjects', function($join) {
								      $join->on('timetables.subject_id', '=', 'subjects.id');
								    })
								    ->leftJoin('classes', function($join) {
								      $join->on('classes.id', '=', 'timetables.class_id');
								    })
								    ->where('timetable_schedule_id', '=', $ts['id'])
									->where('staff_id', Auth::user()->profile_id)
									->orderBy('timetables.timetable_schedule_id')
									->get();	
			$data['attendance'][$i] = AttendanceChart::select('attendance_charts.id', 'attendance_charts.staff_id', 'attendance_charts.class_id','attendance_charts.subject_id','subjects.subject_title', 'subjects.subject_code', 'classes.class', 'classes.class_code','attendance_charts.session_type')
										->leftJoin('subjects', function($join) {
									      $join->on('attendance_charts.subject_id', '=', 'subjects.id');
									    })
									    ->leftJoin('classes', function($join) {
									      $join->on('classes.id', '=', 'attendance_charts.class_id');
									    })
									->where('date', '=', date('Y-m-d'))
									//->where('date', '=', date('2022-01-14'))
									->where('day', '=', $ts['day'])
									->where('period', '=', $ts['period'])
									->where('staff_id', Auth::user()->profile_id)
									->get();	
					
			$i++;					
		}
		//dd($data);
	    return view('/content/pages/page-attendance', $data);
	}

	public function add($timetable_schedule_id){

		if(!Auth::check()){
			return redirect('/login');
		}
		//dd($timetable_schedule_id);
		$data['breadcrumbs'] = [
		        ['link' => "timetable", 'name' => "Timetable"], ['name' => "Add Attendance"]
		    ];
		$timetable_schedule = TimetableSchedule::where('id', $timetable_schedule_id)->get();
		$timetables = Timetable::select('timetables.*', 'subjects.is_elective','subjects.is_second_language', 'subjects.second_language_id')->where('timetable_schedule_id', $timetable_schedule_id)
							->where('staff_id', Auth::user()->profile_id)
							->leftJoin('subjects', function($join) {
							    $join->on('subjects.id', '=', 'timetables.subject_id');
							})
							->get();
		$classes = [];
		$k = 0;
		foreach($timetables as $t){
			if($k==0){
				$data['subject_id'] = $t['subject_id'];
				$data['semester_id'] = $t['semester_id'];
				$data['staff_id'] = $t['staff_id'];
				$data['session_type'] = $t['session_type'];
				$data['is_elective'] = $t['is_elective'];
				$data['is_second_language'] = $t['is_second_language'];
				$data['second_language_id'] = $t['second_language_id'];
			}
			$data['class'][] = $t->class_id;
			$data['timetable_id'][] = $t->id;
			$k++;
		}
		foreach($timetable_schedule as $ts){
			$data['day'] = $ts->day;
			$data['period'] = $ts->period;
		}
		$data['date'] = date('Y-m-d');
		//$data['date'] = date('2022-01-14');
		$data['session_type'] = 'Regular';

		if($data['is_elective'] == 1){
			$subject_type = 'Elective';
		}elseif($data['is_second_language'] == 1){
			$subject_type = 'SL';
		}else{
			$subject_type = 'Regular';
		}
		//dd($subject_type);
		switch($subject_type){
			case 'Elective':
				$data['students'] = Student::select('students.id', 'students.roll_no','students.name','students.class_id', 'classes.class_code')
					->whereIn('students.class_id', $data['class'])->where('students.status', '1')
					->leftJoin('classes', function($join) {
					    $join->on('classes.id', '=', 'students.class_id');
					})
					->orderBy('students.roll_no', 'asc')
					->get();
				break;
			case 'SL':
				$data['students'] = Student::select('students.id', 'students.roll_no','students.name','students.class_id', 'classes.class_code')
					->whereIn('students.class_id', $data['class'])->where('students.status', '1')
					->where('second_language_allotments.second_language_id', $data['second_language_id'])
					->leftJoin('classes', function($join) {
					    $join->on('classes.id', '=', 'students.class_id');
					})
					->leftJoin('second_language_allotments', function($join) {
						$join->on('second_language_allotments.student_id', '=', 'students.id');
					})
					->orderBy('students.roll_no', 'asc')
					->get();
				break;
			case 'Regular':
				$data['students'] = Student::select('students.id', 'students.roll_no','students.name','students.class_id', 'classes.class_code')
					->whereIn('students.class_id', $data['class'])->where('students.status', '1')
					->leftJoin('classes', function($join) {
					    $join->on('classes.id', '=', 'students.class_id');
					})
					->orderBy('students.roll_no', 'asc')
					->get();
				break;
		}
		//dd($data['students']);
		$attendance_exists = 0;
		$attendance_staff_name = '';
		foreach($data['students'] as $s){
			$m = 0;
			for($m=0; $m<=6; $m++){
				if($attendance_exists == 0){
					$data['students_attendance'][$s->id][$m] = Attendance::select('attendances.attendance', 'staffs.name')
						
						->where('attendance_charts.date','=', $data['date'])
						->where('attendance_charts.day', 'LIKE', $data['day'])
						->where('attendance_charts.period', '=', $m)
						->where('attendances.student_id', '=', $s->id)
						->leftJoin('attendance_charts', function($join) {
							$join->on('attendance_charts.id', '=', 'attendances.attendance_chart_id');
						})
						->leftJoin('staffs', function($join) {
							$join->on('staffs.id', '=', 'attendance_charts.staff_id');
						})
						->get();
					if($m == $data['period']){
						if(count($data['students_attendance'][$s->id][$m]) > 0){
							$attendance_exists = 1;
							$attendance_staff_name = $data['students_attendance'][$s->id][$m][0]['name'];
						}
					}
				}else{
					break;
				}
			}
			
		}
		//dd($data['students_attendance']);
		if($attendance_exists == 1){
			return redirect('/attendance')->with('error',"Attendance for this session has been already submitted by ".$attendance_staff_name."!");
		}else{
			return view('/content/pages/page-attendance-add', $data);	
		}
		

	}

	public function insert(Request $request){
		//dd($request);
		$class_id = unserialize($request->class_id);
		$attendance_exists = 0;
		foreach($class_id as $cl){

		}

		//dd($request);
		if($request->session_type == 'Substitute'){
			foreach(unserialize($request->class_id) as $c){
				Timetable::create([
					'timetable_schedule_id' => $request->timetable_schedule_id,
					'staff_id' => $request->staff_id,
					'class_id' => $c,
					'subject_id' => $request->subject_id,
					'semester_id' => $request->semester_id,
					'session_type' => $request->session_type
				]
				);
			}
		}
		
		foreach($class_id as $c){
			$array['date'] = $request->date;
			$array['day'] = $request->day;
			$array['period'] = $request->period;
			$array['timetable_id'] = $request->timetable_id;
			$array['staff_id'] = $request->staff_id;
			$array['class_id'] = $c;
			$array['semester_id'] = $request->semester_id;
			$array['subject_id'] = $request->subject_id;
			$array['session_type'] = $request->session_type;
			$attendance_chart = DB::table('attendance_charts')->insertGetId([
				'date' => $array['date'],
				'day' => $array['day'],
				'period' => $array['period'],
				'timetable_id' => $array['timetable_id'],
				'staff_id' => $array['staff_id'],
				'class_id' => $array['class_id'],
				'semester_id' => $array['semester_id'],
				'subject_id' => $array['subject_id'],
				'session_type' => $array['session_type'],
			]);

			//echo $attendance_chart.'<br/>';
			if($request->is_elective == 1){
				$subject_type = 'Elective';
			}elseif($request->is_second_language == 1){
				$subject_type = 'SL';
			}else{
				$subject_type = 'Regular';
			}
			//dd($subject_type);
			switch($subject_type){
				case 'Elective':
					$students = Student::select('students.id', 'students.roll_no','students.name','students.class_id', 'classes.class_code')
						->where('students.class_id', $array['class_id'])->where('students.status', '1')
						->leftJoin('classes', function($join) {
						    $join->on('classes.id', '=', 'students.class_id');
						})
						->orderBy('students.roll_no', 'asc')
						->get();
					break;
				case 'SL':
					$students = Student::select('students.id', 'students.roll_no','students.name','students.class_id', 'classes.class_code')
						->where('students.class_id', $array['class_id'])->where('students.status', '1')
						->where('second_language_allotments.second_language_id', $request->second_language_id)
						->leftJoin('classes', function($join) {
						    $join->on('classes.id', '=', 'students.class_id');
						})
						->leftJoin('second_language_allotments', function($join) {
							$join->on('second_language_allotments.student_id', '=', 'students.id');
						})
						->orderBy('students.roll_no', 'asc')
						->get();
					break;
				case 'Regular':
					$students = Student::select('students.id', 'students.roll_no','students.name','students.class_id', 'classes.class_code')
						->where('students.class_id', $array['class_id'])->where('students.status', '1')
						->leftJoin('classes', function($join) {
						    $join->on('classes.id', '=', 'students.class_id');
						})
						->orderBy('students.roll_no', 'asc')
						->get();
					break;
			}

			foreach($students as $s){
				$a = 'attendance_'.$s->id;
				echo $s->name;
				echo $a.'<br/>';
				$attendance = DB::table('attendances')->insert([
					'attendance_chart_id' => $attendance_chart,
					'student_id' => $s->id,
					'attendance' => $request->$a,
				]);
			}
			$attencance_chart = NULL;

		}

		return redirect('/attendance')->with('success',"Attendance added successfully!");
	}


	public function edit(Request $request){
		//dd($request);
		//var_dump(unserialize($request->attendance_chart_id));
		//die();
		$data['attendance'] = Attendance::select('attendances.attendance_chart_id', 'attendances.student_id', 'attendances.attendance', 'students.roll_no', 'students.name', 'classes.class_code')->whereIn('attendances.attendance_chart_id', unserialize($request->attendance_chart_id))
									->leftJoin('students', function($join) {
								      $join->on('attendances.student_id', '=', 'students.id');
								    })
								    ->leftJoin('classes', function($join) {
								      $join->on('classes.id', '=', 'students.class_id');
								    })
							->orderBy('attendances.id')
							->get();
		$data['attendance_chart'] = AttendanceChart::whereIn('id', unserialize($request->attendance_chart_id))
				->get();
				//dd($data);
		$data['date'] = $request->date;
		$data['day'] = $request->day;
		$data['period'] = $request->period;
		$data['staff_id'] = $request->staff_id;
		$data['subject_id'] = $request->subject_id;
		$data['timetable_schedule_id'] = $request->timetable_schedule_id;
		$data['class'] = $request->class_id;
		$data['semester_id'] = $request->semester_id;
		$data['session_type'] = $request->session_type;
		$data['attendance_chart_id'] = $request->attendance_chart_id;
		$data['timetable_id'] = $request->timetable_id;
		//dd($data);

		//New code for other periods attendance data - begins
		$attendance_staff_name = '';
		foreach($data['attendance'] as $s){
			//dd($s);
			$m = 0;
			for($m=0; $m<=6; $m++){
					$data['students_attendance'][$s->student_id][$m] = Attendance::select('attendances.attendance', 'staffs.name')
						
						->where('attendance_charts.date','=', $data['date'])
						->where('attendance_charts.day', 'LIKE', $data['day'])
						->where('attendance_charts.period', '=', $m)
						->where('attendances.student_id', '=', $s->student_id)
						->leftJoin('attendance_charts', function($join) {
							$join->on('attendance_charts.id', '=', 'attendances.attendance_chart_id');
						})
						->leftJoin('staffs', function($join) {
							$join->on('staffs.id', '=', 'attendance_charts.staff_id');
						})
						->get();
				
			}
			
		}
		// /dd($data['students_attendance']);
		////New code for other periods attendance data - ends
		return view('/content/pages/page-attendance-edit', $data);
	}

	public function update(Request $request){
		//dd($request);
		//var_dump(unserialize($request->class_id));
		//die();

		$class_id = unserialize($request->class_id);

		foreach($class_id as $c){
			//var_dump($request->attendance_chart_id);
			//die();
			$students = Student::where('class_id', $c)->where('status', '1')->get();

			foreach($students as $s){
				$a = 'attendance_'.$s->id;
				$attendance = DB::table('attendances')->whereIn('attendance_chart_id', unserialize($request->attendance_chart_id))
					->where('student_id','=', $s->id)
					->update([
					'attendance' => $request->$a,
				]);
			}

		}

		return redirect('/attendance')->with('success',"Attendance updated successfully!");
	}


	public function process(Request $request){
		//dd($request);
		switch($request->submit){
			case 'attendance':
				return redirect('/attendance/add/'.$request->timetable_schedule_id);
				//$this->add($request->timetable_schedule_id);
				break;
			case 'substitute':
				return redirect('/timetable/create_substitute/'.$request->day.'/'.$request->period.'/'.$request->timetable_schedule_id);
				break;
			case 'view_attendance':
				//dd($request);
				
				$data['attendance'] = Attendance::select('attendances.attendance_chart_id', 'attendances.student_id', 'attendances.attendance', 'students.roll_no', 'students.name', 'classes.class_code')->whereIn('attendances.attendance_chart_id', $request->attendance_chart_id)
									->leftJoin('students', function($join) {
								      $join->on('attendances.student_id', '=', 'students.id');
								    })
								    ->leftJoin('classes', function($join) {
								      $join->on('classes.id', '=', 'students.class_id');
								    })
							->orderBy('attendances.id')
							->get();
				$data['attendance_chart'] = AttendanceChart::whereIn('id', $request->attendance_chart_id)
					->get();
					//dd($data);
				$data['date'] = $data['attendance_chart'][0]['date'];
				$data['day'] = $request->day;
				$data['period'] = $request->period;
				$data['staff_id'] = $data['attendance_chart'][0]['staff_id'];
				$data['subject_id'] = $data['attendance_chart'][0]['subject_id'];
				$data['timetable_schedule_id'] = $request->timetable_schedule_id;
				$data['class'] = $request->class_id;
				$data['semester_id'] = $data['attendance_chart'][0]['semester_id'];
				$data['session_type'] = $data['attendance_chart'][0]['session_type'];
				$data['attendance_chart_id'] = $request->attendance_chart_id;
				$data['timetable_id'] = $request->timetable_id;

				foreach($data['attendance'] as $s){
				$m = 0;
				for($m=0; $m<=6; $m++){
					//echo $m.' - '.$data['date'].' - '.$data['day'].' - '.$m.' - '.$s->id.'<br/>';
					//die();
					$data['students_attendance'][$s->id][$m] = Attendance::select('attendances.attendance')
						
						->where('attendance_charts.date','=', $data['date'])
						->where('attendance_charts.day', 'LIKE', $data['day'])
						->where('attendance_charts.period', '=', $m)
						->where('attendances.student_id', '=', $s->id)
						->leftJoin('attendance_charts', function($join) {
							$join->on('attendance_charts.id', '=', 'attendances.attendance_chart_id');
						})
						->get();
				}
				
			}

				
				return view('/content/pages/page-attendance-view', $data);
				break;
			case 'delete':
				foreach($request->timetable_id as $t){
					Timetable::where('id', $t)->delete();
				}
				return redirect('/timetable');
				break;
		}
		
		
	}

	public function assign_substitute(Request $request){
		//dd($request);
		if(!Auth::check()){
			return redirect('/login');
		}
      	$timetable_schedule_id = $request->timetable_schedule_id;
		$data['breadcrumbs'] = [
		        ['link' => "Attendance", 'name' => "Attendance"], ['name' => "Add Substitute Attendance"]
		    ];
		$timetable_schedule = TimetableSchedule::where('id', $timetable_schedule_id)->get();
	

		foreach($timetable_schedule as $ts){
			$data['day'] = $ts->day;
			$data['period'] = $ts->period;
		}

		$subject_info = Subject::select('is_elective', 'is_second_language', 'second_language_id')
						->where('id','=',  $request->subject)
						->get();

		$data['is_elective'] = $subject_info[0]['is_elective'];
		$data['is_second_language'] = $subject_info[0]['is_second_language'];
		$data['second_language_id'] = $subject_info[0]['second_language_id'];
		$data['timetable_schedule_id'] = $request->timetable_schedule_id;
		$data['subject_id'] = $request->subject;
		$data['semester_id'] = $request->semester_id;
		$data['staff_id'] = $request->staff_id;
		$data['class'] = $request->classes;
		$data['date'] = date('Y-m-d');
		//$data['date'] = date('2022-01-14');
		$data['session_type'] = 'Substitute';

		if($subject_info[0]['is_elective'] == 1){
			$subject_type = 'Elective';
		}elseif($subject_info[0]['is_second_language'] == 1){
			$subject_type = 'SL';
		}else{
			$subject_type = 'Regular';
		}
		switch($subject_type){
			case 'Elective':
				$data['students'] = Student::select('students.id', 'students.roll_no','students.name','students.class_id', 'classes.class_code')
								->whereIn('students.class_id', $data['class'])->where('students.status', '1')
								->leftJoin('classes', function($join) {
								      $join->on('classes.id', '=', 'students.class_id');
								    })
								->get();
				break;
			case 'SL':
				$data['students'] = Student::select('students.id', 'students.roll_no','students.name','students.class_id', 'classes.class_code')
								->whereIn('students.class_id', $data['class'])->where('students.status', '1')
								->where('second_language_allotments.second_language_id', $data['second_language_id'])
								->where('students.status', '1')
								->leftJoin('second_language_allotments', function($join) {
								      $join->on('second_language_allotments.student_id', '=', 'students.id');
								    })
								->leftJoin('classes', function($join) {
								      $join->on('classes.id', '=', 'students.class_id');
								    })
								->get();
				break;

			case 'Regular':
				$data['students'] = Student::select('students.id', 'students.roll_no','students.name','students.class_id', 'classes.class_code')
								->whereIn('students.class_id', $data['class'])->where('students.status', '1')
								->leftJoin('classes', function($join) {
								      $join->on('classes.id', '=', 'students.class_id');
								    })
								->get();
				break;
		}

		$attendance_exists = 0;
		$attendance_staff_name = '';
		foreach($data['students'] as $s){
			$m = 0;
			for($m=0; $m<=6; $m++){
				if($attendance_exists == 0){
					$data['students_attendance'][$s->id][$m] = Attendance::select('attendances.attendance', 'staffs.name')
						
						->where('attendance_charts.date','=', $data['date'])
						->where('attendance_charts.day', 'LIKE', $data['day'])
						->where('attendance_charts.period', '=', $m)
						->where('attendances.student_id', '=', $s->id)
						->leftJoin('attendance_charts', function($join) {
							$join->on('attendance_charts.id', '=', 'attendances.attendance_chart_id');
						})
						->leftJoin('staffs', function($join) {
							$join->on('staffs.id', '=', 'attendance_charts.staff_id');
						})
						->get();
					if($m == $data['period']){
						if(count($data['students_attendance'][$s->id][$m]) > 0){
							$attendance_exists = 1;
							$attendance_staff_name = $data['students_attendance'][$s->id][$m][0]['name'];
						}
					}
				}else{
					break;
				}
			}
			
		}
		//dd($data);
		if($attendance_exists == 1){
			return redirect('/attendance')->with('error',"Attendance for this session has been already submitted by ".$attendance_staff_name."!");
		}else{
			return view('/content/pages/page-attendance-substitute-add', $data);
		}
	}
}
