<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use DB;

class AuthController extends Controller
{
    // login
    public function login()
    {
    	if(Auth::check()){
			return redirect('/dashboard');
		}
        $breadcrumbs = [
            ['link' => "login", 'name' => "Login"], ['name' => "Login"],['blankPage' => true]
        ];
        return view('/content/authentication/auth-login-cover', ['breadcrumbs' => $breadcrumbs]);
    }

    public function signin(Request $request){
    	$credentials = $request->validate([
            'username' => ['required'],
            'password' => ['required'],
        ]);
    	//dd($credentials);
        if (Auth::attempt($credentials)) {
            //dd(strpos(Auth::user()->domains, 'portal.fmnc.ac.in') == false);
            if(strpos(Auth::user()->domains, 'portal.fmnc.ac.in') == false){
                Auth::logout();
                $request->session()->invalidate();
                $request->session()->regenerateToken();
                return back()->with('error',"Sorry, you are not authorized to access this portal!");                
            }else{

                $request->session()->regenerate();
                $profile_update = DB::table('profile_update')
                     ->select('*')->where('userid', '=', Auth::user()->id)->get();
                foreach($profile_update as $p){
                    if($p->status == 0){
                        return redirect()->intended('update-profile')->with('success',"Login Successfull!");
                    }else{
                        return redirect()->intended('dashboard')->with('success',"Login Successfull!");
                    }
                }

            }
        }

        return back()->with('error',"The provided credentials do not match our records.");
    }

    public function logout(Request $request){
		Auth::logout();
		$request->session()->invalidate();
	    $request->session()->regenerateToken();
	    return redirect('/');
    }
}
