<?php

namespace App\Http\Controllers;
use Illuminate\Support\Facades\Auth;

use Illuminate\Http\Request;
use DB;

class DashboardController extends Controller
{

	public function dashboard()
    {
    	if(!Auth::check()){
			//return redirect('/login');
		}
	    $breadcrumbs = [
		        ['link' => "dashboard", 'name' => "Dashboard"], ['name' => "Index"]
		    ];
	    return view('/content/home', ['breadcrumbs' => $breadcrumbs]);
	}

	public function update_profile()
    {
    	if(!Auth::check()){
			return redirect('/login');
		}
		$data['caste_christian'] = DB::table('castes')->where('religion', '=', 'Christian')->get();
		$data['caste_hindu'] = DB::table('castes')->where('religion', '=', 'Hindu')->get();
		$data['caste_islam'] = DB::table('castes')->where('religion', '=', 'Muslim')->get();
		$data['caste_others'] = DB::table('castes')->where('religion', '=', 'Others')->get();
		$data['staff_info'] = DB::table('staffs')
		             ->select('staffs.*', 'departments.department as department_name', 'designations.designation', 'streams.stream')
		             ->leftJoin('departments', function($join) {
						$join->on('departments.id', '=', 'staffs.department_id');
					 })
					 ->leftJoin('designations', function($join) {
						$join->on('designations.id', '=', 'staffs.designation_id');
					 })
					 ->leftJoin('streams', function($join) {
						$join->on('streams.id', '=', 'staffs.stream_id');
					 })
		             ->where('staffs.id', '=', Auth::user()->profile_id)
		             ->get()->toArray();
    	$data['breadcrumbs'] = [
			        ['link' => "update profile", 'name' => "Update Profile"]
			    ];
	    return view('/content/pages/page-update-profile', $data);
		
	}

	public function save_profile(Request $request)
    {
    	if(!Auth::check()){
			return redirect('/login');
		}
		
	    $staff_array['bio'] = $request->bio;
	    $staff_array['salutation'] = $request->salutation;
	    $staff_array['name'] = $request->name;
	    $staff_array['qualification'] = $request->qualification;
	    $staff_array['specialization'] = $request->specialization;
	    $staff_array['gender'] = $request->gender;
	    $staff_array['dob'] = date('Y-m-d', strtotime($request->dob));
	    $staff_array['date_of_joining'] = date('Y-m-d', strtotime($request->date_of_joining));
	    $staff_array['date_of_retirement'] = date('Y-m-d', strtotime($request->date_of_retirement));
	    $staff_array['primary_mobile'] = $request->primary_mobile;
	    $staff_array['secondary_mobile'] = $request->secondary_mobile;
	    $staff_array['primary_email'] = $request->primary_email;
	    $staff_array['secondary_email'] = $request->secondary_email;
	    $staff_array['aadhaar_no'] = $request->aadhaar_no;
	    $staff_array['present_house_no'] = $request->house_no;
	    $staff_array['present_address'] = $request->street;
	    $staff_array['present_village'] = $request->village;
	    $staff_array['present_taluk'] = $request->taluk;
	    $staff_array['present_city'] = $request->city;
	    $staff_array['present_district'] = $request->district;
	    $staff_array['present_state'] = $request->state;
	    $staff_array['present_country'] = $request->country;
	    $staff_array['present_pincode'] = $request->pincode;
	    $staff_array['permanent_house_no'] = $request->house_no;
	    $staff_array['permanent_address'] = $request->street;
	    $staff_array['permanent_village'] = $request->village;
	    $staff_array['permanent_taluk'] = $request->taluk;
	    $staff_array['permanent_city'] = $request->city;
	    $staff_array['permanent_district'] = $request->district;
	    $staff_array['permanent_state'] = $request->state;
	    $staff_array['permanent_country'] = $request->country;
	    $staff_array['permanent_pincode'] = $request->pincode;
	    $staff_array['religion'] = $request->religion;
	    $staff_array['caste_id'] = $request->caste;
	    $profile = DB::table('staffs')->where('id', Auth::user()->profile_id)
					->update($staff_array);

		$user_array['name'] = $request->name;
		$user_array['email'] = $request->primary_email;
		$profile = DB::table('users')->where('profile_id', Auth::user()->profile_id)
					->where('profile_table', 'staffs')
					->update($user_array);
		$profile_array['status'] = 1;
		$profile_update = DB::table('profile_update')->where('userid', Auth::user()->id)
					->update($profile_array);
		return redirect('/profile')->with('success',"Thankyou! Profile info has been updated successfully!");			
    }

    public function upload(Request $request){
    	if(isset($_FILES['file']['name'])){

	   /* Getting file name */
	   //$filename = $_FILES['file']['name'];
	   $filename = $request->image_name;

	   /* Location */
	   $location = "uploads/profile_pic/staffs/".$filename;
	   $imageFileType = pathinfo($location,PATHINFO_EXTENSION);
	   $imageFileType = strtolower($imageFileType);

	   /* Valid extensions */
	   $valid_extensions = array("jpg","jpeg","png");

	   $response = 0;
	   /* Check file extension */
	   if(in_array(strtolower($imageFileType), $valid_extensions)) {
	      /* Upload file */
	      if(move_uploaded_file($_FILES['file']['tmp_name'],$location)){
	         $response = $location;
	      }
	   }

	   echo $response;
	   exit;
	}

	echo 0;
    }

    public function profile()
    {
    	$data['staff_info'] = DB::table('staffs')
		             ->select('staffs.*', 'departments.department as department_name', 'designations.designation', 'streams.stream', 'castes.caste')
		             ->leftJoin('departments', function($join) {
						$join->on('departments.id', '=', 'staffs.department_id');
					 })
					 ->leftJoin('designations', function($join) {
						$join->on('designations.id', '=', 'staffs.designation_id');
					 })
					 ->leftJoin('streams', function($join) {
						$join->on('streams.id', '=', 'staffs.stream_id');
					 })
					 ->leftJoin('castes', function($join) {
						$join->on('castes.id', '=', 'staffs.caste_id');
					 })
		             ->where('staffs.id', '=', Auth::user()->profile_id)
		             ->get()->toArray();
    	$data['breadcrumbs'] = [
			        ['link' => "profile", 'name' => "Profile"]
			    ];
	    return view('/content/pages/page-profile-view', $data);
    }
}
