<?php

namespace App\Http\Controllers;
use Illuminate\Support\Facades\Auth;

use Illuminate\Http\Request;
use App\Models\TimetableSchedule;
use App\Models\Timetable;
use App\Models\AttendanceChart;
use App\Models\Attendance;
use App\Models\Classes;
use App\Models\Staff;
use App\Models\Batch;
use App\Models\Student;
use App\Models\Subject;
use App\Models\WorkDiaryPlatform;
use App\Models\WorkDiary;
use App\Models\WorkDiaryClass;
use DB;

class TimetableController extends Controller
{
    public function index()
    {
    	if(!Auth::check()){
			return redirect('/login');
		}
	    $data['breadcrumbs'] = [
		        ['link' => "timetable", 'name' => "Timetable"], ['name' => "Index"]
		];

		$data['timetable_schedules'] = TimetableSchedule::all();
		$i = 0;
		foreach($data['timetable_schedules'] as $t){
			$data['timetables'][$i] = Timetable::select('timetables.id', 'timetables.staff_id', 'timetables.class_id','timetables.subject_id','subjects.subject_title', 'subjects.subject_code', 'classes.class', 'classes.class_code')
									
									->leftJoin('subjects', function($join) {
								      $join->on('timetables.subject_id', '=', 'subjects.id');
								    })
								    ->leftJoin('classes', function($join) {
								      $join->on('classes.id', '=', 'timetables.class_id');
								    })
								    ->where('staff_id',Auth::user()->profile_id)
									->where('timetable_schedule_id', $t['id'])
									->where('session_type', 'NOT LIKE','Substitute')
									->orderBy('timetables.timetable_schedule_id')
									->get();	
			$i++;
		}
		

	    //return view('/content/pages/page-timetable', ['breadcrumbs' => $breadcrumbs]);
	    return view('/content/pages/page-timetable', $data);
	}

	public function create($day, $period, $timetable_schedule_id){
		if(!Auth::check()){
			return redirect('/login');
		}

		$data['day'] = $day;
		$data['period'] = $period;
		$data['timetable_schedule_id'] = $timetable_schedule_id;
	    $data['breadcrumbs'] = [
		        ['link' => "timetable", 'name' => "Timetable"], ['name' => "Create"]
		];
		$data['batches'] = Batch::where('status', 1)
				->orderBy('id')
				->get();
		$data['staffs'] = Staff::where('status', 1)
				->where('id',Auth::user()->profile_id)
				->orderBy('id')
				->get();
		$data['classes'] = Classes::where('status', 1)
				->orderBy('id')
				->get();
		$data['semester_id'] = $data['classes'][0]['semester_id'];

	    return view('/content/pages/page-timetable-create', $data);
	}

	public function create_substitute($day, $period, $timetable_schedule_id){
		if(!Auth::check()){
			return redirect('/login');
		}

		$data['day'] = $day;
		$data['period'] = $period;
		$data['timetable_schedule_id'] = $timetable_schedule_id;
	    $data['breadcrumbs'] = [
		        ['link' => "timetable", 'name' => "Timetable"], ['name' => "Create"]
		];
		$data['batches'] = Batch::where('status', 1)
				->orderBy('id')
				->get();
		$data['staffs'] = Staff::where('status', 1)
				->where('id',Auth::user()->profile_id)
				->orderBy('id')
				->get();
		$data['classes'] = Classes::where('status', 1)
				->orderBy('id')
				->get();
		$data['semester_id'] = $data['classes'][0]['semester_id'];

	    return view('/content/pages/page-timetable-create-substitute', $data);
	}

	public function getClassByBatch($id){
		$data['classes'] = Classes::where('status', 1)
				->where('batch_id', $id)
				->orderBy('id')
				->get();
		return $data;
	}

	public function assign(Request $request){
		//dd($request);
		if(!Auth::check()){
			return redirect('/login');
		}
		if($_POST != NULL){
			$subject = Subject::select('is_elective', 'is_second_language')
						->where('id',$request->subject)
						->get();

			foreach($request->classes as $c){
				$timetable = DB::table('timetables')
		             ->select('*')
		             ->where('timetables.class_id', '=', $c)
		             ->where('timetable_schedules.day', '=', $request->day)
		             ->where('timetable_schedules.period', '=', $request->period)
		             ->where('timetables.session_type', '=', 'Regular')
		             ->leftJoin('timetable_schedules', function($join) {
								      $join->on('timetable_schedules.id', '=', 'timetables.timetable_schedule_id');
								    })
		            ->leftJoin('staffs', function($join) {
								      $join->on('staffs.id', '=', 'timetables.staff_id');
								    })
		            ->rightJoin('subjects', function($join) {
								      $join->on('subjects.id', '=', 'timetables.subject_id');
								    })
		             ->get();
		             //dd($timetable);
		        $timetable_exists =0;
		        if(count($timetable) > 0){
		        	$is_elective_or_second_language = 0;
		        	foreach($timetable as $t){
		        		if($t->is_elective == 0 && $t->is_second_language == 0){
		        			$is_elective_or_second_language = 0;
		        			$timetable_exists =1;
		        		}else{
		        			if($subject[0]['is_elective'] == 1){
		        				if($t->is_elective == $subject[0]['is_elective']){
			        				$is_elective_or_second_language = 1;
			        				$timetable_exists =0;
			        			}
		        			}elseif($subject[0]['is_second_language'] == 1){
		        				if($t->is_second_language == $subject[0]['is_second_language']){
			        				$is_elective_or_second_language = 1;
			        				$timetable_exists =0;
			        			}
		        			}else{
		        				$is_elective_or_second_language = 0;
		        				$timetable_exists =1;
		        			}
		        		}
		        	} 
		        	//dd($timetable_exists);
		        	//
		        }

		        if($timetable_exists == 1){
		        	return redirect('/timetable')->with('error',"This class has been already assigned by ".$t->salutation.' '.$t->name."!");
		        }else{
					$semester = Classes::select('semester_id')->where('id', $request->classes[0])->limit('1')->get();
					foreach($semester as $s){
						$semester_id = $s;
					}
					
					if($_POST != NULL){
						foreach($request->classes as $c){
							Timetable::create([
								'timetable_schedule_id' => $request->timetable_schedule_id,
								'staff_id' => $request->staff_id,
								'class_id' => $c,
								'subject_id' => $request->subject,
								'semester_id' => $semester_id['semester_id'],
								'session_type' => $request->session_type
							]
							);
						}
						return redirect('/timetable');
					}else{
						return redirect('/login');
					}
		        }
		    }
		}else{
			return redirect('/login');
		}
		


	}

	public function process(Request $request){
		//dd($request);
		switch($request->submit){
			case 'delete':
				foreach($request->timetable_id as $t){
					Timetable::where('id', $t)->delete();
				}
				return redirect('/timetable')->with('warning',"The requested timetable has been removed successfully!");
				break;
		}
	}

	public function work_diary(){
		$data['breadcrumbs'] = [
		        ['link' => "timetable/work-diary", 'name' => "Work diary"], ['name' => "Index"]
		];
		$data['work_diary'] = WorkDiary::select('work_diaries.*', 'work_diary_platforms.platform')
				->where('work_diaries.staff_id', Auth::user()->profile_id)
				->leftJoin('work_diary_platforms', function($join) {
								      $join->on('work_diary_platforms.id', '=', 'work_diaries.work_diary_platform_id');
								    })
				->orderBy('work_diaries.id')
				->get();
		$i = 0;
		foreach($data['work_diary'] as $w){
			$data['classes'][$w['id']] = WorkDiaryClass::select('classes.class')
							->leftJoin('classes', function($join) {
								      $join->on('work_diary_classes.class_id', '=', 'classes.id');
								    })
							->where('work_diary_id','=', $w['id'])
							->get();
			$i++;	

		}
		// /dd($classes);
		//$data['list'] = $data['work_diary']->toJson();
		//dd($data);
		//dd($data['work_diary']->toJson());
		return view('/content/pages/page-work-diary-list', $data);
	}

	public function work_diary_data(){
		$data['work_diary'] = WorkDiary::where('staff_id', Auth::user()->profile_id)
				->orderBy('id')
				->get();
		return $list = '{"data":'.$data['work_diary']->toJson().'}';

	}

	public function work_diary_add(){
		$data['breadcrumbs'] = [
		        ['link' => "timetable/work-diary", 'name' => "Work diary"], ['name' => "Add"]
		];
		$data['classes'] = Classes::where('status', 1)
				->orderBy('id')
				->get();
		$data['platform'] = WorkDiaryPlatform::orderBy('platform')
				->get();
		return view('/content/pages/page-work-diary-add', $data);
	}

	public function work_diary_save(Request $request){
		//dd($request->classes);
		$array['staff_id'] = Auth::user()->profile_id;
		$array['date'] = $request->date;
		$array['time_from'] = $request->time_from;
		$array['time_to'] = $request->time_to;
		$array['work_type'] = $request->work_type;
		$array['work_title'] = $request->title;
		$array['work_diary_platform_id'] = $request->platform;
		$array['total_no_of_students'] = $request->s_total;
		$array['total_no_of_attendance'] = $request->p_total;
		$array['remarks'] = $request->remarks;
		$work_diary = WorkDiary::insertGetId($array);
		//dd($request->classes);
		if($request->work_type == 'class'){
			foreach($request->classes as $c){
				$array_2['work_diary_id'] = $work_diary;
				$array_2['class_id'] = $c;
				WorkDiaryClass::insert($array_2);
			}
		}
		
		return redirect('/timetable/work-diary')->with('success',"Work Diary added successfully!");
	}

	public function work_diary_view($work_diary_id){
		$data['breadcrumbs'] = [
		        ['link' => "timetable/work-diary", 'name' => "Work diary"], ['name' => "View"]
		];
		$data['work_diary'] = WorkDiary::select('work_diaries.*', 'work_diary_platforms.platform')
				->where('work_diaries.id',$work_diary_id)
				->leftJoin('work_diary_platforms', function($join) {
								      $join->on('work_diary_platforms.id', '=', 'work_diaries.work_diary_platform_id');
								    })
				->orderBy('work_diaries.id')
				->get();
		$i = 0;
		foreach($data['work_diary'] as $w){
			$data['classes'][$w['id']] = WorkDiaryClass::select('classes.class')
							->leftJoin('classes', function($join) {
								      $join->on('work_diary_classes.class_id', '=', 'classes.id');
								    })
							->where('work_diary_id','=', $w['id'])
							->get();
			$i++;	

		}
		// /dd($classes);
		//$data['list'] = $data['work_diary']->toJson();
		//dd($data);
		//dd($data['work_diary']->toJson());
		return view('/content/pages/page-work-diary-view', $data);
	}

	public function work_diary_delete($work_diary_id){
		if($work_diary_id != NULL){
			WorkDiaryClass::where('work_diary_id', $work_diary_id)->delete();
			WorkDiary::where('id', $work_diary_id)->delete();
			
	
			return redirect('/timetable/work-diary')->with('success',"The requested work diary log has been removed successfully!");
		}else{
			return redirect('/timetable/work-diary')->with('warning',"No log has been removed!");
		}
	}

	public function work_diary_edit($work_diary_id){
		$data['breadcrumbs'] = [
		        ['link' => "timetable/work-diary", 'name' => "Work diary"], ['name' => "View"]
		];
		$data['work_diary'] = WorkDiary::select('work_diaries.*', 'work_diary_platforms.platform')
				->where('work_diaries.id',$work_diary_id)
				->leftJoin('work_diary_platforms', function($join) {
								      $join->on('work_diary_platforms.id', '=', 'work_diaries.work_diary_platform_id');
								    })
				->orderBy('work_diaries.id')
				->get();
		$i = 0;
		foreach($data['work_diary'] as $w){
			$data['work_diary_classes'][$w['id']] = WorkDiaryClass::select('classes.id', 'classes.class')
							->leftJoin('classes', function($join) {
								      $join->on('work_diary_classes.class_id', '=', 'classes.id');
								    })
							->where('work_diary_id','=', $w['id'])
							->get()->pluck('id')->toArray();
			$i++;	

		}
		$data['classes'] = Classes::where('status', 1)
				->orderBy('id')
				->get();
		$data['platform'] = WorkDiaryPlatform::orderBy('platform')
				->get();
		// /dd($classes);
		//$data['list'] = $data['work_diary']->toJson();
		//dd($data);
		//dd($data['work_diary']->toJson());
		return view('/content/pages/page-work-diary-edit', $data);
	}

	
}
